/**************************************************  DMA Functions Header  ***************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright 2012, Red Rapids, Inc.

**************************************************  DMA Functions Header  ***************************************************/

#ifndef _DMA_FUNCTIONS_H_
#define _DMA_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Structure to store the DMA configuration settings.
typedef struct
{
	unsigned long BurstSizeB;
	unsigned long BurstCount;
	unsigned long PageCount;
	unsigned long PagesPerMark;
} s_DMABuffer;

// Structure to store the results returned by a DMA status query to the device.
typedef struct
{
	unsigned long CurrentPage;
	unsigned long CurrentBurst;
	unsigned long Engine[3];
} s_DMAStatus;

// Prototypes for each of the DMA functions.
unsigned long DMAAllocate(s_Adapter *p_HW, unsigned long ChannelNumber, s_DMABuffer DMABuffer);
unsigned long DMAConfigCheck(s_DMABuffer DMABuffer, size_t SettingNumber);
unsigned long GetDMAStatus(s_Adapter *p_HW, unsigned long ChannelNumber, s_DMAStatus *p_DMAStatus);
unsigned long DMAFree(s_Adapter *p_HW, unsigned long ChannelNumber);

#ifdef __cplusplus
}
#endif

#endif
